// FILENAME:	WhackAGoad.cs
// 3:21 AM 8/2/99
// AUTHORS:  	Orogogus
//------------------------------------------------------------------------------

$missionName = "Whack-a-Goad";

exec("multiplayerStdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}


Pilot GoadMole
{
   id = 28;
   
   skill = 0.8;
   accuracy = 0.8;
   aggressiveness = 0.5;
   activateDist = 2000.0;
   deactivateBuff = 3000.0;
   targetFreq = 4.0;
   trackFreq = 0.1;
   fireFreq = 0.1;
   LOSFreq = 0.4;
   name = "GoadMole";
};

$boxes = 3;
$goads = 3;
$maxListing = 10;

for (%i=0; %i<=%boxes; %i++)
{
$boxOwner[%i] = 0;
}

for (%i=0; %i<=%boxes; %i++)
{
$Countbox[%i] = 0;
}


//============

for ( %i=0; %i<$maxListing; %i++ )
{
	$bestTime[%i] = 9999;
	$bestTimeString[%i] = "";
	$bestTimeVehicle[%i] = "";
	$victor[%i] = "";
}

$maxPersonalBest = 0;
$personalBest[0] = 0;
$personalBestName[0] = "Captain Placeholder";
$personalBestStreak[0] = 0;



//============


function onMissionStart()
{
	marsSounds();
	$startTime = getCurrentTime();
}


function onMissionLoad(){
   cdAudioCycle("Purge", "Terror", "Watching"); 
}


function setDefaultMissionItems() 
{
	exec("defaultVehicles");
	allowComponent("all", true);
	allowWeapon("all", true);
}


//=============


function BeamHimUp::trigger::onEnter(%this, %vehicleId)
{

	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);

	%check = 0;

	for ( %i=0; %i<3; %i++ )
	{
		if($boxOwner[%i] == 0)
		{
		%check = 1;
		}
	}

	if(%check == 1)
	{
		%Scotty = randomInt(0, 2);

		while($boxOwner[%Scotty] != 0)
		{
			%Scotty = randomInt(0, 2);
		}


		if(%Scotty == 0)
		{
			%x = -165;
			%y = 5;
			%z = 100;
			$boxOwner[0] = %player;
		}

		else if(%Scotty == 1)
		{
			%x = 385;
			%y = 100;
			%z = 100;
			$boxOwner[1] = %player;
		}

		else if(%Scotty == 2)
		{
			%x = 20;
			%y = 445;
			%z = 100;
			$boxOwner[2] = %player;
		}

		setPosition( getObjectId(%vehicleId), %x, %y, %z );
		$Countbox[%Scotty] = $goads;
		%player.home = %Scotty;
		setMoles(%Player, %Scotty);
		setHudTimer(5000, 1, "Time", 1, %player);
		%player.time = getCurrentTime();
	}
	else
	{
		%txt1 = "Sorry, all boxes full.  Please try again later.";
		say(%player, 0, %txt1);
	}
}



function setMoles(%player, %box)
{

	%playerVeh = playerManager::playerNumToVehicleId(%player);

	for ( %i=0; %i<$goads; %i++ )
	{
		%herc = NewObject("GoadMole", Herc, 21 ); 
		setTeam( %herc, *IDSTR_TEAM_PURPLE );
		setPilotId(%herc,28);
		putGoad( %herc, %box);
		order( %herc, attack, %playerVeh );
		%herc.home = %box;
		%player.AI[%i] = %herc;
	}
}


function putGoad(%herc, %box)
{
	if (%box == 0)
	{
		randomTransport(%herc, -295, -140, -40, 115);
	}

	else if (%box == 1)
	{
		randomTransport(%herc, 260, -50, 520, 215);
	}

	else if (%box == 2)
	{
		randomTransport(%herc, -110, 300, 155, 555);
	}

}


//================


function vehicle::onAdd(%vehicle)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicle);
    if(%player == 0) return;
	%player.home = 100;
	%player.name = getHUDName(%vehicle);
	%player.streak = 0;
	%player.vehicle = getVehicleName(%vehicle);
	setVehicleRadarVisible( %vehicle, False );
}


function vehicle::onDestroyed( %victimVeh, %destroyerVeh )
{

	if( getTeam( %victimVeh ) == *IDSTR_TEAM_PURPLE )
	{
		%box = %victimVeh.home;
		%player = $boxOwner[%box];

		$Countbox[%box]--;

		if($Countbox[%box] == 0)
		{
			$boxOwner[%player.home] = 0;
			%player.home = 100;
			%player.streak++;

			setHudTimer(0, 0, "", 1, %player);                  
			%timeCompleted = (getCurrentTime() - %player.time);
			%timeString = timeDifference(getCurrentTime(), %player.time);

			say(%player, 0, "Goads whacked in " @ %timeString);

			$check = 0;

			for( %i=0; %i<($maxPersonalBest + 1); %i++ )
			{
				if($personalBestName[%i] == %player.name)
				{
					$check = 1;

					if(%player.streak > $personalBestStreak[%i])
					{
						$personalBestStreak[%i] = %player.streak;
					}

					if(%timeCompleted < $personalBest[%i])
					{
						say(%player, 0, "A new personal best!!");
						$personalBest[%i] = %timeCompleted;
						$personalBestString[%i] = %timeString;
					}
				}
			}

			if($check == 0)
			{
				$maxPersonalBest++;
				say(%player, 0, "\(First completion for " @ %player.name@ "\)");
				$personalBestName[$maxPersonalBest] = %player.name;
				$personalBest[$maxPersonalBest] = %timeCompleted;
				$personalBestString[$maxPersonalBest] = %timeString;
				$personalBestStreak[$maxPersonalBest] = %player.streak;
			}

			%winner = 0;
			%highNumber = 10;

			for ( %i=($maxListing-1); %i>-1; %i-- )
			{
				if( %timeCompleted < $bestTime[%i] )
				{
					%winner = 1;
					%highNumber = %i;
				}
			}


			if(%winner == 1)
			{

				for ( %j=($maxListing-1); %j>(%highNumber-1); %j-- )
				{
					$bestTime[(%j+1)] = $bestTime[%j];
					$bestTimeString[(%j+1)] = $bestTimeString[%j];
					$bestTimeVehicle[(%j+1)] = $bestTimeVehicle[%j];
					$victor[(%j+1)] = $victor[(%j)];
				}

				$bestTime[%highNumber] = %timeCompleted;
				$bestTimeString[%highNumber] = %timeString;
				$bestTimeVehicle[%highNumber] = %player.vehicle;
				$victor[%highNumber] = %player.name;

//				writeScores();

				%ordinal = getOrdinal(%highNumber);

				say("everybody", 1, %player.name @" has scored "@%ordinal @" place!  \(" @%timeString @"\)");

				say(%player, 0, "You win a giant stuffed bear!!!");

			}
			else
			{
				say(%player, 0, "Congratulations, you win a kewpie doll!");
			}


			healObject( %destroyerVeh, 50000);
			healObject( %destroyerVeh, 50000);
			reloadObject( %destroyerVeh, 100);
			healObject( %destroyerVeh, 50000);
			randomTransport( %destroyerVeh, -75, -700, -15, -505 );
		}
	}

	else
	{
		%player = playerManager::vehicleIdToPlayerNum(%victimVeh);
		%box = %player.home;
		setHudTimer(0, 0, "", 1, %player);                  
		if (%box != 100)
		{
		say(%player, 0, "Whoops.  The Goads nailed you.  Better luck next time.");
		}

		for ( %i=0; %i<$goads; %i++ )
		{
			if ( %player.AI[%i] )
			deleteObject( %player.AI[%i] );
		}

		$Countbox[%box] = 0;
		$boxOwner[%box] = 0;
		%player.home = 100;
	}
}


function player::onRemove( %player )
{

	for ( %i=0; %i<$goads; %i++ )
	{
		if ( %player.AI[%i] )
		deleteObject( %player.AI[%i] );
	}

	$Countbox[%player.home] = 0;
	$boxOwner[%player.home] = 0;
}
	


//==========================


function Scoreboard1::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	%player.name = getHUDName(%vehicleId);

	%check = 0;

	for( %i=0; %i<($maxPersonalBest + 1); %i++ )
	{
		if($personalBestName[%i] == %player.name)
		{
			%check = 1;
			say(%player, 0, "Welcome back, " @%player.name @"!");
			say(%player, 0, "Your personal best time is " @$personalBestString[%i] @".");
			say(%player, 0, "Your best streak is " @$personalBestStreak[%i] @" in a row.");
		}
	}

	if(%check == 0)
	{
		say(%player, 0, "Hello, " @%player.name @"!");
		say(%player, 0, "You have not registered any victories in this game yet.");
	}

	%now = getCurrentTime();
	%timeUp = timeDifference( %now, $startTime);
	say(%player, 0, "The server has been up for " @%timeUp );

}


function Scoreboard2::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	%player.name = getHUDName(%vehicleId);

	if($bestTime[0] == 9999)
	{
		say(%player, 0, "No best scores yet: the Goads are still unbeaten.");
	}
	
	else
	{
		say(%player, 0, "Today's best times:");

		for (%i=($maxListing-1); %i>-1; %i--)
		{
			if($bestTime[%i] != 9999)
			{
				%ordinal = getOrdinal(%i);
				say(%player, 0, "- "@%ordinal @" place by " @$victor[%i] @ " \("@ $bestTimeVehicle[%i] @ "\: " @$bestTimeString[%i] @ "\)");
			}
		}
	}

}


//===================

//function writeScores()
//{
//	for (%i=$maxListing; %i>-1; %i--)
//	{
//		fileWrite("WhackGoadScore.cs", append, "$bestTime["@%i @"] = "@ $bestTime[%i] );
//	}
//
//	for (%i=$maxListing; %i>-1; %i--)
//	{
//		fileWrite("WhackGoadScore.cs", append, "$bestTimeString["@%i @"] = "@ $bestTimeString[%i] );
//	}
//
//	for (%i=$maxListing; %i>-1; %i--)
//	{
//		fileWrite("WhackGoadScore.cs", append, "$bestTimeVehicle["@%i @"] = "@ $bestTimeVehicle[%i] );
//	}
//
//	for (%i=$maxListing; %i>-1; %i--)
//	{
//		fileWrite("WhackGoadScore.cs", append, "$victor["@%i @"] = "@ $victor[%i] );
//	}
//}


function getOrdinal(%highPlace)
{
	if(%highplace==0)
	{
		return("1st");
	}
	else if(%highplace==1)
	{
		return("2nd");
	}
	else if(%highplace==2)
	{
		return("3rd");
	}
	else if(%highplace==3)
	{
		return("4th");
	}
	else if(%highplace==4)
	{
		return("5th");
	}
	else if(%highplace==5)
	{
		return("6th");
	}
	else if(%highplace==6)
	{
		return("7th");
	}
	else if(%highplace==7)
	{
		return("8th");
	}
	else if(%highplace==8)
	{
		return("9th");
	}
	else if(%highplace==9)
	{
		return("10th");
	}
	else
	{
		return(%highplace + 1);
	}
}

